glibmm: Gio::DataInputStream Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gio::DataInputStream Class Reference
Stream Classes

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations). More...

`#include <giomm/datainputstream.h>`

Inheritance diagram for Gio::DataInputStream:
[legend]

List of all members.

## Public Member Functions
virtual | ~DataInputStream ()
GDataInputStream* | gobj ()
| Provides access to the underlying C GObject.
const GDataInputStream* | gobj () const
| Provides access to the underlying C GObject.
GDataInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_byte_order (DataStreamByteOrder order)
| This function sets the byte order for the given stream.
DataStreamByteOrder | get_byte_order () const
| Gets the byte order for the data input stream.
void | set_newline_type (DataStreamNewlineType type)
| Sets the newline type for the stream.
DataStreamNewlineType | get_newline_type () const
| Gets the current newline type for the stream.
guchar | read_byte (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 8-bit/1-byte value from stream.
guchar | read_byte ()
| non-cancellable version of read_byte()
gint16 | read_int16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 16-bit/2-byte value from stream.
gint16 | read_int16 ()
| non-cancellable version of read_int16()
guint16 | read_uint16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 16-bit/2-byte value from stream.
guint16 | read_uint16 ()
| non-cancellable version of read_uint16()
gint32 | read_int32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a signed 32-bit/4-byte value from stream.
gint32 | read_int32 ()
| non-cancellable version of read_int32()
guint32 | read_uint32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 32-bit/4-byte value from stream.
guint32 | read_uint32 ()
| non-cancellable version of read_uint32()
gint64 | read_int64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 64-bit/8-byte value from stream.
gint64 | read_int64 ()
| non-cancellable version of read_int64()
guint64 | read_uint64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 64-bit/8-byte value from stream.
guint64 | read_uint64 ()
| non-cancellable version of read_uint64()
bool | read_line (std::string& line, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a line from the data input stream.
bool | read_line (std::string& line)
| A non-cancellable version of read_line().
void | read_line_utf8 (std::string& line, const Glib::RefPtr< Cancellable >& cancellable, gsize& length)
| Reads a UTF-8 encoded line from the data input stream.
void | read_line_utf8 (std::string& line, const Glib::RefPtr< Cancellable >& cancellable)
| A read_line_utf8() convenience overload.
void | read_line_utf8 (std::string& line, gsize& length)
| A read_line_utf8() convenience overload.
void | read_line_utf8 (std::string& line)
| A read_line_utf8() convenience overload.
void | read_line_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_until().
bool | read_line_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_line_async().
void | read_line_finish_utf8 (const Glib::RefPtr< AsyncResult >& result, std::string& data, gsize& length)
| Finish an asynchronous call started by g_data_input_stream_read_line_async().
void | read_line_finish_utf8 (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| A read_line_finish_utf8() convenience overload.
bool | read_until (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters.
bool | read_until (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_until().
void | read_until_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_until().
bool | read_until_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_until_async().
bool | read_upto (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters.
bool | read_upto (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_upto().
void | read_upto_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_upto().
bool | read_upto_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_upto_async().
Glib::PropertyProxy < DataStreamByteOrder > | property_byte_order ()
| The byte order.
Glib::PropertyProxy_ReadOnly < DataStreamByteOrder > | property_byte_order () const
| The byte order.
Glib::PropertyProxy < DataStreamNewlineType > | property_newline_type ()
| The accepted types of line ending.
Glib::PropertyProxy_ReadOnly < DataStreamNewlineType > | property_newline_type () const
| The accepted types of line ending.
Public Member Functions inherited from Gio::BufferedInputStream
virtual | ~BufferedInputStream ()
gsize | get_buffer_size () const
| Gets the size of the input buffer.
void | set_buffer_size (gsize size)
| Sets the size of the internal buffer of stream to size, or to the size of the contents of the buffer.
gsize | get_available () const
| Gets the size of the available data within the stream.
gsize | peek (void* buffer, gsize offset, gsize count) const
| Peeks in the buffer, copying data of size count into buffer, offset offset bytes.
const void* | peek_buffer (gsize&count) const
| Returns the buffer with the currently available bytes.
gssize | fill (gssize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer.
gssize | fill (gssize count)
| non-cancellable version of fill()
void | fill_async (const SlotAsyncReady& slot, gssize count, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Reads data into the stream's buffer asynchronously, up to count size.
void | fill_async (const SlotAsyncReady& slot, gssize count, int io_priority=Glib::PRIORITY_DEFAULT)
| Reads data into the stream's buffer asynchronously, up to count size.
gssize | fill_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous read.
Glib::PropertyProxy< guint > | property_buffer_size ()
| The size of the backend buffer.
Glib::PropertyProxy_ReadOnly < guint > | property_buffer_size () const
| The size of the backend buffer.
Public Member Functions inherited from Gio::FilterInputStream
virtual | ~FilterInputStream ()
Glib::RefPtr< InputStream > | get_base_stream ()
| Gets the base stream for the filter stream.
Glib::RefPtr< const InputStream > | get_base_stream () const
| Gets the base stream for the filter stream.
bool | get_close_base_stream () const
| Returns whether the base stream will be closed when stream is closed.
void | set_close_base_stream (bool close_base=true)
| Sets whether the base stream will be closed when stream is closed.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< InputStream > > | property_base_stream () const
| The underlying base stream on which the io ops will be done.
Glib::PropertyProxy< bool > | property_close_base_stream ()
| If the base stream should be closed when the filter stream is closed.
Glib::PropertyProxy_ReadOnly < bool > | property_close_base_stream () const
| If the base stream should be closed when the filter stream is closed.
Public Member Functions inherited from Gio::InputStream
virtual | ~InputStream ()
gssize | read (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
gssize | read (void* buffer, gsize count)
| Tries to read count bytes from the stream into the buffer starting at buffer.
bool | read_all (void* buffer, gsize count, gsize& bytes_read, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer.
bool | read_all (void* buffer, gsize count, gsize& bytes_read)
| Tries to read count bytes from the stream into the buffer starting at buffer.
gssize | skip (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to skip count bytes from the stream.
gssize | skip (gsize count)
| Tries to skip count bytes from the stream.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| Closes the stream, releasing resources related to it.
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer.
gssize | read_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read operation.
void | skip_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
void | skip_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer.
gssize | skip_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes a stream skip operation.
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it.
gboolean | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async().
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Static Public Member Functions
static Glib::RefPtr < DataInputStream > | create (const Glib::RefPtr< InputStream >& base_stream)
| Creates a new InputStream from the given base_stream, with a buffer set to the default size (4 kilobytes).
Static Public Member Functions inherited from Gio::BufferedInputStream
static Glib::RefPtr < BufferedInputStream > | create_sized (const Glib::RefPtr< InputStream >& base_stream, gsize buffer_size)
| Creates a new InputStream from the given base_stream, with a buffer set to size.

## Protected Member Functions
| DataInputStream (const Glib::RefPtr< InputStream >& base_stream)
Protected Member Functions inherited from Gio::BufferedInputStream
| BufferedInputStream (const Glib::RefPtr< InputStream >& base_stream)
| BufferedInputStream (const Glib::RefPtr< InputStream >& base_stream, gsize buffer_size)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::DataInputStream > | wrap (GDataInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::BufferedInputStream
Glib::RefPtr < Gio::BufferedInputStream > | wrap (GBufferedInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::FilterInputStream
Glib::RefPtr < Gio::FilterInputStream > | wrap (GFilterInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Detailed Description

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations).

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::DataInputStream::~DataInputStream | ( |  | ) |
| virtual

Gio::DataInputStream::DataInputStream | ( | const Glib::RefPtr< InputStream >& | base_stream | ) |
| explicitprotected

## Member Function Documentation

static Glib::RefPtr<DataInputStream> Gio::DataInputStream::create | ( | const Glib::RefPtr< InputStream >& | base_stream | ) |
| static

Creates a new InputStream from the given base_stream, with a buffer set to the default size (4 kilobytes).

Parameters:

  base_stream | An InputStream.

Returns:
  an InputStream for the given base_stream.

Reimplemented from Gio::BufferedInputStream.

DataStreamByteOrder Gio::DataInputStream::get_byte_order | ( |  | ) | const

Gets the byte order for the data input stream.

Returns:
  The stream's current DataStreamByteOrder.

DataStreamNewlineType Gio::DataInputStream::get_newline_type | ( |  | ) | const

Gets the current newline type for the stream.

Returns:
  DataStreamNewlineType for the given stream.

GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

const GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::BufferedInputStream.

GDataInputStream* Gio::DataInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::BufferedInputStream.

Glib::PropertyProxy< DataStreamByteOrder > Gio::DataInputStream::property_byte_order | ( |  | ) |

The byte order.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< DataStreamByteOrder > Gio::DataInputStream::property_byte_order | ( |  | ) | const

The byte order.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< DataStreamNewlineType > Gio::DataInputStream::property_newline_type | ( |  | ) |

The accepted types of line ending.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< DataStreamNewlineType > Gio::DataInputStream::property_newline_type | ( |  | ) | const

The accepted types of line ending.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

guchar Gio::DataInputStream::read_byte | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 8-bit/1-byte value from stream.

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 8-bit/1-byte value read from the stream or %0 if an error occurred.

Reimplemented from Gio::BufferedInputStream.

guchar Gio::DataInputStream::read_byte | ( |  | ) |

non-cancellable version of read_byte()

Reimplemented from Gio::BufferedInputStream.

gint16 Gio::DataInputStream::read_int16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A signed 16-bit/2-byte value read from stream or %0 if an error occurred.

gint16 Gio::DataInputStream::read_int16 | ( |  | ) |

non-cancellable version of read_int16()

gint32 Gio::DataInputStream::read_int32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a signed 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  A signed 32-bit/4-byte value read from the stream or %0 if an error occurred.

gint32 Gio::DataInputStream::read_int32 | ( |  | ) |

non-cancellable version of read_int32()

gint64 Gio::DataInputStream::read_int64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  A signed 64-bit/8-byte value read from stream or %0 if an error occurred.

gint64 Gio::DataInputStream::read_int64 | ( |  | ) |

non-cancellable version of read_int64()

bool Gio::DataInputStream::read_line | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a line from the data input stream.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

Parameters:

  data | A string to fill with the read data (without the newlines).
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_line | ( | std::string & | line | ) |

A non-cancellable version of read_line().

Parameters:

  data | A string to fill with the read data (without the newlines).

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_line_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_until().

It is an error to have two outstanding calls to this function.

Parameters:

  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_line_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_line_async().

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_line_finish_utf8 | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data,
|  | gsize & | length
| ) |  |

Finish an asynchronous call started by g_data_input_stream_read_line_async().

Since glibmm 2.30:

Parameters:

  result | The AsyncResult that was provided to the callback.
  length | A #gsize to get the length of the data read in.

Returns:
  A string with the line that was read in (without the newlines). Set length to a #gsize to get the length of the read line. On an error, it will return `0` and error will be set. For UTF-8 conversion errors, the set error domain is CONVERT_ERROR. If there's no content to read, it will still return `0`, but error won't be set.

void Gio::DataInputStream::read_line_finish_utf8 | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

A read_line_finish_utf8() convenience overload.

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | gsize & | length
| ) |  |

Reads a UTF-8 encoded line from the data input stream.

If cancellable is not `0`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error IO_ERROR_CANCELLED will be returned.

Since glibmm 2.30:

Parameters:

  length | A #gsize to get the length of the data read in.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A NUL terminated UTF-8 string with the line that was read in (without the newlines). Set length to a #gsize to get the length of the read line. On an error, it will return `0` and error will be set. For UTF-8 conversion errors, the set error domain is CONVERT_ERROR. If there's no content to read, it will still return `0`, but error won't be set.

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

A read_line_utf8() convenience overload.

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | gsize & | length
| ) |  |

A read_line_utf8() convenience overload.

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line | ) |

A read_line_utf8() convenience overload.

guint16 Gio::DataInputStream::read_uint16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  An unsigned 16-bit/2-byte value read from the stream or %0 if an error occurred.

guint16 Gio::DataInputStream::read_uint16 | ( |  | ) |

non-cancellable version of read_uint16()

guint32 Gio::DataInputStream::read_uint32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  An unsigned 32-bit/4-byte value read from the stream or %0 if an error occurred.

guint32 Gio::DataInputStream::read_uint32 | ( |  | ) |

non-cancellable version of read_uint32()

guint64 Gio::DataInputStream::read_uint64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  cancellable | Cancellable object.

Returns:
  An unsigned 64-bit/8-byte read from stream or %0 if an error occurred.

guint64 Gio::DataInputStream::read_uint64 | ( |  | ) |

non-cancellable version of read_uint64()

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Both functions will be marked as deprecated in a future release. Use read_upto() instead, but note that that method does not consume the stop character.

Parameters:

  data | A string to fill with the read data.
  stop_chars | Characters to terminate the read.
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_until().

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Both functions will be marked as deprecated in a future release. Use read_upto() instead, but note that that method does not consume the stop character.

Parameters:

  stop_chars | Characters to terminate the read.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_until_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_until().

It is an error to have two outstanding calls to this function.

Note that, in contrast to ead_until(), this function does not consume the stop character that it finds. You must read it for yourself.

Don't use this function in new code. Its functionality is inconsistent with read_until(). Both functions will be marked as deprecated in a future release. Use read_upto_async() instead.

Parameters:

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_until_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_until_async().

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

In contrast to read_until(), this method does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters:

  data | A string to fill with the read data.
  stop_chars | Characters to terminate the read.
  cancellable | A cancellable object.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_upto().

Parameters:

  stop_chars | Characters to terminate the read.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::read_upto_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_upto().

It is an error to have two outstanding calls to this function.

In contrast to read_until(), this method does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters:

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Returns:
  true if the read succeeded without error.

bool Gio::DataInputStream::read_upto_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_upto_async().

Note that this function does <emphasis>not</emphasis> consume the stop character. You have to use read_byte() to get it before calling read_upto_async() again.

Parameters:

  result | The AsyncResult that was provided to the callback slot.
  data | A string to fill with the read data.

Returns:
  true if the read succeeded without error.

void Gio::DataInputStream::set_byte_order | ( | DataStreamByteOrder | order | ) |

This function sets the byte order for the given stream.

All subsequent reads from the stream will be read in the given order.

Parameters:

  order | A DataStreamByteOrder to set.

void Gio::DataInputStream::set_newline_type | ( | DataStreamNewlineType | type | ) |

Sets the newline type for the stream.

Note that using G_DATA_STREAM_NEWLINE_TYPE_ANY is slightly unsafe. If a read chunk ends in "CR" we must read an additional byte to know if this is "CR" or "CR LF", and this might block if there is no more data available.

Parameters:

  type | The type of new line return as DataStreamNewlineType.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DataInputStream > wrap | ( | GDataInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.